<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ImprimeDocumentoInterno StructType
 * @subpackage Structs
 */
class ImprimeDocumentoInterno extends AbstractStructBase
{
    /**
     * The filial
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $filial;
    /**
     * The tipoDoc
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $tipoDoc;
    /**
     * The serie
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $serie;
    /**
     * The numdoc
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $numdoc;
    /**
     * The numeroVias
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $numeroVias;
    /**
     * The usarViasERP
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $usarViasERP;
    /**
     * Constructor method for ImprimeDocumentoInterno
     * @uses ImprimeDocumentoInterno::setFilial()
     * @uses ImprimeDocumentoInterno::setTipoDoc()
     * @uses ImprimeDocumentoInterno::setSerie()
     * @uses ImprimeDocumentoInterno::setNumdoc()
     * @uses ImprimeDocumentoInterno::setNumeroVias()
     * @uses ImprimeDocumentoInterno::setUsarViasERP()
     * @param string $filial
     * @param string $tipoDoc
     * @param string $serie
     * @param int $numdoc
     * @param int $numeroVias
     * @param bool $usarViasERP
     */
    public function __construct($filial = null, $tipoDoc = null, $serie = null, $numdoc = null, $numeroVias = null, $usarViasERP = null)
    {
        $this
            ->setFilial($filial)
            ->setTipoDoc($tipoDoc)
            ->setSerie($serie)
            ->setNumdoc($numdoc)
            ->setNumeroVias($numeroVias)
            ->setUsarViasERP($usarViasERP);
    }
    /**
     * Get filial value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFilial()
    {
        return isset($this->filial) ? $this->filial : null;
    }
    /**
     * Set filial value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $filial
     * @return \StructType\ImprimeDocumentoInterno
     */
    public function setFilial($filial = null)
    {
        // validation for constraint: string
        if (!is_null($filial) && !is_string($filial)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($filial)), __LINE__);
        }
        if (is_null($filial) || (is_array($filial) && empty($filial))) {
            unset($this->filial);
        } else {
            $this->filial = $filial;
        }
        return $this;
    }
    /**
     * Get tipoDoc value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTipoDoc()
    {
        return isset($this->tipoDoc) ? $this->tipoDoc : null;
    }
    /**
     * Set tipoDoc value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tipoDoc
     * @return \StructType\ImprimeDocumentoInterno
     */
    public function setTipoDoc($tipoDoc = null)
    {
        // validation for constraint: string
        if (!is_null($tipoDoc) && !is_string($tipoDoc)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tipoDoc)), __LINE__);
        }
        if (is_null($tipoDoc) || (is_array($tipoDoc) && empty($tipoDoc))) {
            unset($this->tipoDoc);
        } else {
            $this->tipoDoc = $tipoDoc;
        }
        return $this;
    }
    /**
     * Get serie value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSerie()
    {
        return isset($this->serie) ? $this->serie : null;
    }
    /**
     * Set serie value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $serie
     * @return \StructType\ImprimeDocumentoInterno
     */
    public function setSerie($serie = null)
    {
        // validation for constraint: string
        if (!is_null($serie) && !is_string($serie)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($serie)), __LINE__);
        }
        if (is_null($serie) || (is_array($serie) && empty($serie))) {
            unset($this->serie);
        } else {
            $this->serie = $serie;
        }
        return $this;
    }
    /**
     * Get numdoc value
     * @return int|null
     */
    public function getNumdoc()
    {
        return $this->numdoc;
    }
    /**
     * Set numdoc value
     * @param int $numdoc
     * @return \StructType\ImprimeDocumentoInterno
     */
    public function setNumdoc($numdoc = null)
    {
        // validation for constraint: int
        if (!is_null($numdoc) && !is_numeric($numdoc)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($numdoc)), __LINE__);
        }
        $this->numdoc = $numdoc;
        return $this;
    }
    /**
     * Get numeroVias value
     * @return int|null
     */
    public function getNumeroVias()
    {
        return $this->numeroVias;
    }
    /**
     * Set numeroVias value
     * @param int $numeroVias
     * @return \StructType\ImprimeDocumentoInterno
     */
    public function setNumeroVias($numeroVias = null)
    {
        // validation for constraint: int
        if (!is_null($numeroVias) && !is_numeric($numeroVias)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($numeroVias)), __LINE__);
        }
        $this->numeroVias = $numeroVias;
        return $this;
    }
    /**
     * Get usarViasERP value
     * @return bool|null
     */
    public function getUsarViasERP()
    {
        return $this->usarViasERP;
    }
    /**
     * Set usarViasERP value
     * @param bool $usarViasERP
     * @return \StructType\ImprimeDocumentoInterno
     */
    public function setUsarViasERP($usarViasERP = null)
    {
        // validation for constraint: boolean
        if (!is_null($usarViasERP) && !is_bool($usarViasERP)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($usarViasERP)), __LINE__);
        }
        $this->usarViasERP = $usarViasERP;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ImprimeDocumentoInterno
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
